#!/bin/sh
. /srv/www/include/cgi-helper
show_html_header "Hosts I/O"
. /var/run/hosts_io.conf

if [ "$FORM_action" = "" ]
then
 FORM_action="opt_anzeigen"
fi
_opt_anzeigen="Hosts"
show_tab_header "$_opt_anzeigen" "$myname?action=anzeigen"

echo '<a href="'$0'">Aktualisieren</a><br>'

if [ "$FORM_aufgabe" = "shutdown" ]
then
 #echo "$HOSTS_IO_SERVERLISTE" | grep -q "/$FORM_ip/"
 #if [ "$?" = "0" ]
 #then
 # check_rights "host_io" "server"
 # echo "Server $FORM_ip kann nur vom Administrator heruntergefahren werden!"
 #else
  echo "Schalte $FORM_ip aus!"  # (dazu mu�sclient.exe laufen)
   idx=1
   while [  "$idx" -le "$HOSTS_IO_SHUTDOWN_N" ]
   do
    eval ip='$HOSTS_IO_SHUTDOWN_'$idx'_IP'
    if [ "$ip" = "$FORM_ip" ]
    then
     eval befehl='$HOSTS_IO_SHUTDOWN_'$idx'_COMMAND'
     befehl=$( echo "$befehl" | sed "s/%IP/$REMOTE_ADDR/g" )
     eval $befehl &
    fi
    idx=`/usr/bin/expr $idx + 1`
   done
 #fi
 echo "<hr>"
fi

if [ "$FORM_aufgabe" = "wake" ]
then
 echo "Wecke $FORM_ip auf!<br>"
 cut -d" " -f4 /var/run/wol.conf | grep -q "$FORM_$ip"
 if [ "$?" = "0" ]
 then
  wol.sh "$FORM_ip"
 else

   idx=1
   while [  "$idx" -le "$HOSTS_IO_SPEZIALWAKE_N" ]
   do
    eval ip='$HOSTS_IO_SPEZIALWAKE_'$idx'_IP'
    if [ "$ip" = "$FORM_ip" ]
    then
     eval befehl='$HOSTS_IO_SPEZIALWAKE_'$idx'_COMMAND'
     befehl=$( echo "$befehl" | sed "s/%IP/$REMOTE_ADDR/g" )
     eval $befehl &
    fi
    idx=`/usr/bin/expr $idx + 1`
   done
 fi
 echo "<hr>"
fi
#cat /etc/hosts | grep -v "^#" | cut -d" " -f 1
#cat /etc/hosts | grep -v "^#" | cut -d" " -f 2

# Die gewnschte IP-Liste zusammenstellen:
echo "$HOSTS_IO_IPLISTE" | sed 's/\//\n/g' > /tmp/host_io.ip
if [ "$HOSTS_IO_BASE" = "yes" ]
then
 cat /etc/hosts | grep -v "^#" | cut -d" " -f 1 >> /tmp/host_io.ip
fi
if [ "$HOSTS_IO_WOL" = "yes" ]
then
 cut -d" " -f4 /var/run/wol.conf >> /tmp/host_io.ip
fi
if [ "$HOSTS_IO_DHCP" = "yes" ]
then
  cut -d" " -f 3 /var/ramcopy/log/dnsmasq.leases >> /tmp/host_io.ip
fi



echo "<table border>"
echo "<tr><th>Host [IP]</th><th>Zustand</th><th>Schalten</th></tr>"
#echo -e "$( cat /etc/hosts | grep -v "^#" | cut -d" " -f 1 )\n$( cut -d" " -f 3 /var/ramcopy/log/dnsmasq.leases )" |
sort /tmp/host_io.ip | uniq | grep -v "127.0.0.1" | fping -c 1 -n -A -f -  2>&1 >/dev/nul |
sed -e "s! *: xmt/rcv/%loss = 1/0/100%! aus!" -e "s! *: xmt/rcv/%loss = 1/1/0%, min/avg/max =.*! AN!" |
while read line
do
 if [ "$line" != "" ]
 then
  name=$( echo "$line" | cut -d" " -f 1 )
  #echo "$name"
  ip=$( echo "$line" | sed -e "s/^.*(//" -e "s/).*$//" )
  #echo "$ip"
  zustand=$( echo "$line" | cut -d" " -f 3 )
  #echo "$zustand"
  ancolor=""
  echo "$HOSTS_IO_SERVERLISTE" | grep -q "/$ip/"
  if [ "$?" = "0" ]
   then ancolor="#B0B000"
   else ancolor="green"
  fi
  if [ "$zustand" = "aus" ]
   then
    echo "<tr><td><font color='red'>"
    echo "<b>$name</b> <small>[$ip]</small>"
    echo "</font></td>"
    echo "<td>$zustand</td>"
    echo "<td>"
    #cut -d" " -f4 /var/run/wol.conf | grep -q "$ip"
    ( cut -d" " -f4 /var/run/wol.conf; echo "$HOSTS_IO_SWLISTE" | sed 's/\//\n/g' ) | grep -q "$ip"
    if [ "$?" = "0" ]
     then
      echo "<a href='$0?&aufgabe=wake&ip=$ip'>ANschalten</a>"
    fi
    echo "</td></tr>"
   else
    echo "<tr><td><font color='$ancolor'>"
    echo "<b>$name</b> <small>[$ip]</small>"
    echo "</font></td>"
    echo "<td>$zustand</td>"
    echo "<td>"
    if [ "$ancolor" != "" ]
    then
      echo "$HOSTS_IO_SDLISTE" | grep -q "/$ip/"
      if [ "$?" = "0" ]
      then
       echo "<a href='$0?&aufgabe=shutdown&ip=$ip'>ausschalten</a>"
      fi
    fi
    echo "</td></tr>"
  fi
 fi
done
echo "</table>"

show_tab_footer
show_html_footer
